---
title: Element.animate()
slug: Web/API/Element/animate
tags:
  - API
  - Animation
  - Element
  - Method
  - Reference
  - Web Animations
---
<div>{{APIRef('Web Animations')}}</div>

<p>The {{domxref("Element")}} interface's <strong><code>animate()</code></strong> method is a shortcut method which creates a new {{domxref("Animation")}}, applies it to the element, then plays the animation. It returns the created {{domxref("Animation")}} object instance.</p>

<div class="note">
<p>Elements can have multiple animations applied to them. You can get a list of the animations that affect an element by calling {{domxref("Element.getAnimations()")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>animation</em> = element.animate(<em>keyframes</em>, <em>options</em>); </pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>keyframes</code></dt>
 <dd>
 <p>Either an array of keyframe objects, <strong>or</strong> a keyframe object whose property are arrays of values to iterate over. See <a href="/en-US/docs/Web/API/Web_Animations_API/Keyframe_Formats">Keyframe Formats </a>for more details.</p>
 </dd>
 <dt><code>options</code></dt>
 <dd>Either an<strong> integer representing the animation's duration</strong> (in milliseconds), <strong>or</strong> an Object containing one or more timing properties: </dd>
 <dd>
 <dl>
  <dt><code>id {{optional_inline}}</code></dt>
  <dd>A property unique to <code>animate()</code>: a <a href="/en-US/docs/Web/API/DOMString" title="DOMString is a UTF-16 String. As JavaScript already uses such strings, DOMString is mapped directly to a String."><code>DOMString</code></a> with which to reference the animation.</dd>
 </dl>
 {{Page("/en-US/docs/Web/API/Web_Animations_API/Animation_timing_properties", "Properties")}}</dd>
</dl>

<p>You can also include a composite operation or iteration composite operation in your options list:</p>

<dl>
 <dt><code><a href="/en-US/docs/Web/API/KeyframeEffect/composite">composite</a> {{optional_inline}}</code></dt>
 <dd>Determines how values are combined between this animation and other, separate animations that do not specify their own specific composite operation. Defaults to <code>replace</code>.
 <ul>
  <li><code>add</code> dictates an additive effect, where each successive iteration builds on the last. For instance with <code>transform</code>, a <code>translateX(-200px)</code> would not override an earlier <code>rotate(20deg)</code> value but result in <code>translateX(-200px) rotate(20deg)</code>.</li>
  <li><code>accumulate</code> is similar but a little smarter: <code>blur(2)</code> and <code>blur(5)</code> become <code>blur(7)</code>, not <code>blur(2) blur(5)</code>.</li>
  <li><code>replace</code> overwrites the previous value with the new one. </li>
 </ul>
 </dd>
 <dt><code><a href="/en-US/docs/Web/API/KeyframeEffect/iterationComposite">iterationComposite</a> {{optional_inline}}</code></dt>
 <dd>Determines how values build from iteration to iteration in this animation. Can be set to <code>accumulate</code> or <code>replace</code> (see above). Defaults to <code>replace</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Returns an {{domxref("Animation")}}.</p>

<h2 id="Examples">Examples</h2>

<p>In the demo <a href="https://codepen.io/rachelnabors/pen/rxpmJL/?editors=0010">Down the Rabbit Hole (with the Web Animation API)</a>, we use the convenient <code>animate()</code> method to immediately create and play an animation on the <code>#tunnel</code> element to make it flow upwards, infinitely. Notice the array of objects passed as keyframes and also the timing options block.</p>

<pre class="brush: js notranslate">document.getElementById("tunnel").animate([
  // keyframes
  { transform: 'translateY(0px)' },
  { transform: 'translateY(-300px)' }
], {
  // timing options
  duration: 1000,
  iterations: Infinity
});
</pre>

<h3 id="Implicit_tofrom_keyframes">Implicit to/from keyframes</h3>

<p>In newer browser versions, you are able to set a beginning or end state for an animation only (i.e. a single keyframe), and the browser will infer the other end of the animation if it is able to. For example, consider <a href="https://mdn.github.io/dom-examples/web-animations-api/implicit-keyframes.html">this simple animation</a> — the Keyframe object looks like so:</p>

<pre class="brush: js notranslate">let rotate360 = [
  { transform: 'rotate(360deg)' }
];</pre>

<p>We have only specified the end state of the animation, and the beginning state is implied.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations 2', '#dom-keyframeeffect-iterationcomposite', 'KeyframeAnimationOptions.iterationComposite' )}}</td>
   <td>{{Spec2('Web Animations 2')}}</td>
   <td>Added the <code>iterationComposite</code> option.</td>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#animatable', 'animate()' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.animate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>{{domxref("Element.getAnimations()")}}</li>
 <li>{{domxref("Animation")}}</li>
</ul>
